package com.madeu.controller.web.webstocksum;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webstocksum.WebStockSumService;
import com.madeu.util.HttpUtil;
import com.madeu.view.web.WebStockSumCompanyView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebStockSumController extends ManagerDraftAction{

	@Autowired
	private WebStockSumService webStockSumService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;

	/**
	 * 현재 재고 제품별 거래처 리스트 조회 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksum/selectListStockSumCompanyIntro.do")
	public String  selectListStockSumCompanyIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebStockSumController  selectListStockSumCompanyIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumService.selectListStockSumCompanyIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebStockSumController  selectListStockSumCompanyIntro END");
		return "/web/stocksum/stockSumSelectList";
	}
	

	
	/**
	 * 현재고 품목수, 품목별재고수, 거래처수, 재고총액 조회 (현재고 상단)
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksum/selectTotalStockSumCompany.do")
	public ModelAndView selectTotalStockSumCompany(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockSumController selectTotalStockSumCompany START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumService.selectTotalStockSumCompany(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockSumController selectTotalStockSumCompany END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * 현재 재고 제품별 거래처 리스트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksum/selectListStockSumCompany.do")
	public ModelAndView selectListStockSumCompany(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockSumController selectListStockSumCompany START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumService.selectListStockSumCompany(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockSumController selectListStockSumCompany END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * <b> 현재 재고 제품별 거래처 리스트 엑셀 다운로드 </b>
	 * 페이지 처리 없음 
	 * request: 
	 * response : msgCode, msgDesc
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksum/downloadStockSumCompanyExcel.do")
	public ModelAndView downloadStockSumCompanyExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebStockSumController downloadStockSumCompanyExcel START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		Map<String, Object> selectListReport = new HashMap<String,Object>();
		Map<String, Object> map = new HashMap<String,Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webStockSumService.selectListStockSumCompanyExcel(paramMap);
				map.put("selectListStockSumCompany", selectListReport);
				map.put("name", "stocksum");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebStockSumController downloadStockSumCompanyExcel END");
		return new ModelAndView(new WebStockSumCompanyView(),"map",map);
	}
}
